package io.zipcoder;

import java.util.concurrent.locks.ReadWriteLock;
import java.util.concurrent.locks.ReentrantReadWriteLock;

/**
 * Make this extend the Copier like `UnsafeCopier`, except use locks to make sure that the actual intro gets printed
 * correctly every time.  Make the run method thread safe.
 */
public class SafeCopier extends Copier {

    ReadWriteLock instanceOfReadWriteLock;


    public SafeCopier(String toCopy) {
        super(toCopy);
        instanceOfReadWriteLock = new ReentrantReadWriteLock();
    }

    public void run() {

        instanceOfReadWriteLock.writeLock().lock();
        instanceOfReadWriteLock.readLock().lock();

        try {
            while (stringIterator.hasNext()) {
                copied += stringIterator.next() + " ";
            }

        } finally {
            instanceOfReadWriteLock.writeLock().unlock();
            instanceOfReadWriteLock.readLock().unlock();
        }

    }

}